VAR_SLOT_RAM		EQU		#F200
VAR_SUBSLOT_RAM		EQU		#F201

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;					USAR COM DI!!!!!!!!!!!!!!! EI!
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; MUFF FIND RAM
;	POPULA F200 E F201 COM O SLOT E SUBSLOT (CASO ESTEJA EM SUBSLOT) ONDE TEM RAM NA PRIMEIRA POSIO
;	EX: SE F200 = 03
;	E F201 = 01
;	QUER DIZER QUE NO SLOT 3-1, TEM RAM NA POSIO 0000
;	SE O F201 FOR $94, QUER DIZER QUE A RAM EST EM UM LUGAR SIMPLES
; 	DETALHE, SE O VALOR NO VAR_SLOT_RAM $F200 FOR $76, QUER DIZER QUE A MAQUINA NAO TEM RAM NA PAGINA 0, O QUE IMPEDE AS CONVERSOES
; 	DE RODAREM...
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
MUFF_FIND_RAM:
	LD A,$76
	LD (VAR_SLOT_RAM),A			; INICIALIZA VARIAVEIS COM 76
	LD (VAR_SUBSLOT_RAM),A
	
	LD C,0					; CONTADOR DE SLOT
	LD HL,$FCC0
RS_LOOP:
	IN A,($A8)
	LD B,A					; SALVO O SLOT ORIGINAL
	AND %11111100
	ADD A,C
	OUT ($A8),A				; SLOT (DE 0 A 3) J EST NA POSIO 0    XPTO XPTO XPTO (LOOP SLOT)
	INC HL					; 
	LD A,(HL)
	CP $80
	JR NZ,RS_SLOT_SIMPLES	; SENO,  SLOT EXPANDIDO E DAE, TENHO QUE FAZER OUTRO LOOP
	
	LD D,C					; D TER O SLOT MASTER
	PUSH BC
	PUSH HL
	LD B,0
	LD HL,$FCC5				; AQUI, BC TER O SLOT EM QUE ESTOU. VOU ADICIONAR PRA PEGAR O EXPANDIDO CORRETO PQE BC AINDA TEM O SLOT MASTER
	ADD HL,BC
	LD C,0					; CONTADOR DE SUB-SLOT
RS_LOOP_EXP:
	LD A,(HL)
	LD B,A					; SALVO O SUB-SLOT ORIGINAL
	AND %11111100
	ADD A,C
	PUSH BC
	PUSH DE
	CALL MUDA_SUBSLOT_D		; EXTENDIDO JAH TEM NA POSIO 0: XPTO XPTO XPTO (LOOP SLOT 0-3)  - D TEM O SLOT A MEXER
	POP DE
	POP BC
	PUSH HL					; RAM TEST ROUTINE
	LD HL,$1076
	LD (HL),$76
	LD A,(HL)
	POP HL
	CP $76
	CALL Z, RS_FOUNDRAM		; ACHEI RAM NA POSICAO ZERO...
	
	LD A,B					; VAMOS RECOLOCAR O VALOR ORIGINAL NO SUB-SLOT
	PUSH BC
	PUSH DE
	CALL MUDA_SUBSLOT_D
	POP DE
	POP BC
	
	;INC HL					; ISTO EH FIXO
	INC C
	LD A,C
	CP $4					; CHEGUEI NO ULTIMO SUB-SLOT?
	JR NZ,RS_LOOP_EXP
	POP HL
	POP BC					; POP DA ROTINA DE EXTENDIDO...
	JR RS_NEXTSLOT
	
RS_SLOT_SIMPLES:
	PUSH HL
	LD HL,$1076
	LD (HL),$76
	LD A,(HL)
	POP HL
	CP $76
	CALL Z, RS_FOUNDRAM2

RS_NEXTSLOT:	
	LD A,B
	OUT ($A8),A				; VOLTEI A CONFIGURAAO ORIGINAL
	
	INC C
	LD A,C
	CP $4					; CHEGUEI NO ULTIMO SLOT?
	JR NZ,RS_LOOP
	RET	
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;	GRAVA NO SUBSLOT INDICADO
;	D  = SLOT PARA MEXER NO EXPANDIDO
;	A = VALOR PARA COLOCAR NO EXPANDIDO
MUDA_SUBSLOT_D:
	LD B,A
	LD A,D
	RLCA
	RLCA
	RLCA
	RLCA
	RLCA
	RLCA
	LD C,A
	IN A,($A8)
	LD E,A					; E TEM O ORIGINAL
	AND %00111111
	ADD A,C					; C TEM O SLOT A MEXER, ROTACIONADO PRA PAGINA 3
	OUT ($A8),A				; TROCADO O SLOT DA PAGINA 3
	LD A,B					; B TEM  AGORA O VALOR A COLOCAR NO SUBSLOT
	LD ($FFFF),A
	LD A,E
	OUT ($A8),A				; VOLTA DA PAGINA ORIGINAL
	RET


RS_FOUNDRAM:				; ACHOU RAM EM SLOT EXPANDIDO
	LD A,D
	LD (VAR_SLOT_RAM),A
	LD A,C					; SE NAO TEM 94, QUER DIZER QUE O SLOT EH SIMPLES.
	LD (VAR_SUBSLOT_RAM),A
	RET
	
RS_FOUNDRAM2:				; ACHOU RAM EM SLOT SIMPLES
	LD A,C
	LD (VAR_SLOT_RAM),A
	LD A,$94				; PRA INDICAR QUE O SLOT COM RAM EH SIMPLES
	LD (VAR_SUBSLOT_RAM),A
	RET

;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;	ESTA ROTINA COLOCA RAM NA PGINA 0 E PREPARA O SLOT (OU SUBSLOT) PARA QUE TROCAR A PAGINA 1 SEJA TRIVIAL...
;;;;	OU SEJA, A8 XX XX XX RAM, PEGAR O RAM E COLOCAR XX XX RAM RAM :)
;;;;;;;;;;;;;;;;;;;;;;;;;;;
COLOCA_RAM_PAGINA0_E_PREP_SUBSLOT:
	LD A,(VAR_SLOT_RAM)
	LD C,A						; C TEM O SLOT DE RAM
	LD A,(VAR_SUBSLOT_RAM)
	CP $94
	JR Z,RAM_SLOT_SIMPLES
	LD B,0
	LD HL,$FCC5
	ADD HL,BC					; 
	LD B,A
	LD A,(HL)
	AND %11110000
	RRCA
	RRCA
	OR B
	RLCA
	RLCA
	OR B
	LD D,C				; SLOT A MEXER
	PUSH BC
	CALL MUDA_SUBSLOT_D	; ESPERO TER COLOCADO NO EXPANDIDO: ORIGINAL ORIGINAL RAM RAM 
	POP BC
RAM_SLOT_SIMPLES:
	IN A,($A8)
	AND %11111100
	ADD A,C						; RAM NA PGINA 0
	OUT ($A8),A
	RET
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;