; by Muffie 2008
JOY_COLECO_SCAN:
		in a,($AA)
		and %11110000		
		OR 0				;Coluna 0 do MSX no b
		out ($AA),a
		in a,($A9)			; Pronto, coluna 0 no A - Nmeros de 0 a 7 do teclado
		cpl					; Vamos inverter os bits...
		
		
		ld d,%00000101		; zero do COLECO
		bit 0,a
		jr nz, CARREGA_FC	; Se no deu zero,  pqe a tecla 0 do MSX est pressionada
		ld d,%00000010		; um do COLECO
		bit 1,a
		jr nz, CARREGA_FC	; Se no deu zero,  pqe a tecla 1 do MSX est pressionada
		ld d,%00001000		; dois do COLECO
		bit 2,a
		jr nz, CARREGA_FC	; Se no deu zero,  pqe a tecla 2 do MSX est pressionada
		ld d,%00000011		; tres do COLECO
		bit 3,a
		jr nz, CARREGA_FC	; Se no deu zero,  pqe a tecla 3 do MSX est pressionada
		ld d,%00001101		; quatro do COLECO
		bit 4,a
		jr nz, CARREGA_FC	; Se no deu zero,  pqe a tecla 4 do MSX est pressionada
		ld d,%00001100		; cinco do COLECO
		bit 5,a
		jr nz, CARREGA_FC	; Se no deu zero,  pqe a tecla 5 do MSX est pressionada
		ld d,%00000001		; seis do COLECO
		bit 6,a
		jr nz, CARREGA_FC	; Se no deu zero,  pqe a tecla 6 do MSX est pressionada
		ld d,%00001010		; sete do COLECO
		bit 7,a
		jr nz, CARREGA_FC	; Se no deu zero,  pqe a tecla 7 do MSX est pressionada
		
		; Coluna 1 do MSX...
		in a,($AA)
		and %11110000		
		OR 1				;Coluna 1 do MSX no b
		out ($AA),a
		in a,($A9)			; Pronto, coluna 1 no A - Nmeros 8 e 9 e -_ e =+
		cpl					; Vamos inverter os bits...

		ld d,%00001110		; oito do COLECO
		bit 0,a
		jr nz, CARREGA_FC	; Se no deu zero,  pqe a tecla 8 do MSX est pressionada
		ld d,%00000100		; nove do COLECO
		bit 1,a
		jr nz, CARREGA_FC	; Se no deu zero,  pqe a tecla 9 do MSX est pressionada
		ld d,%00000110		; * do COLECO
		bit 2,a
		jr nz, CARREGA_FC	; Se no deu zero,  pqe a tecla -_ do MSX est pressionada
		ld d,%00001001		; # do COLECO
		bit 3,a
		jr nz, CARREGA_FC	; Se no deu zero,  pqe a tecla =+ do MSX est pressionada

		; Coluna 4 do MSX...
		in a,($AA)
		and %11110000		
		OR 4				;Coluna 1 do MSX no b
		out ($AA),a
		in a,($A9)			; Pronto, coluna 1 no A - Nmeros 8 e 9 e -_ e =+
		cpl					; Vamos inverter os bits...

		ld d,%01000000		; oito do COLECO
		bit 2,a
		jr nz, CARREGA_FC	; Se no deu zero,  pqe a tecla 8 do MSX est pressionada
	
		
		ld d,%00000000;

		
CARREGA_FC:
		SET 7,D
		
JOYSTICK_TIRO2:

		DI
		LD A,14	
		OUT ($A0),A		; REGISTRADOR 14 DO PSG
		NOP
		NOP
		IN A,($A2)		; PRONTO, TENHO OS BITS DO JOYSTICK
		EI
		CPL
		AND %00111111	; TIREI OS 2 KANA E ETC...
		BIT 5,A
		JR Z,NOT_J2
		SET 6,D			; DEU TIRO COM O JOY2
		
		
NOT_J2:		
		ld a,d
		ld ($73f0),a
		ld ($73f1),a


		; Coluna 8 do MSX...
		in a,($AA)
		and %11110000		
		ld b,8				;Coluna 8 do MSX no b
		or b
		out ($AA),a
		in a,($A9)			; Pronto, coluna 8 no A - setas e espao
		cpl					; Vamos inverter os bits...
		
		SET 7,E
		
		ld e,0
		ld d,0
DIREITA:
		bit 7,a				; Seta Direita?
		jr z,BAIXO
		set 1,e				; Liga bit direita do coleco
BAIXO:
		bit 6,a
		jr z,CIMA
		set 2,e				; Liga bit baixo do coleco
CIMA:
		bit 5,a
		jr z,ESQUERDA
		set 0,e
ESQUERDA:
		bit 4,a
		jr z,TIRO1
		set 3,e
TIRO1:
		bit 0,a
		jr z,FIM_DIREC
		set 6,e
		
FIM_DIREC:

		DI
		LD A,14	
		OUT ($A0),A		; REGISTRADOR 14 DO PSG
		NOP
		NOP
		IN A,($A2)		; PRONTO, TENHO OS BITS DO JOYSTICK
		EI
		CPL
		AND %00111111	; TIREI OS 2 KANA E ETC...

JDIREITA:
		bit 3,a				; Seta Direita?
		jr z,JBAIXO
		set 1,e				; Liga bit direita do coleco
JBAIXO:
		bit 1,a
		jr z,JCIMA
		set 2,e				; Liga bit baixo do coleco
JCIMA:
		bit 0,a
		jr z,JESQUERDA
		set 0,e
JESQUERDA:
		bit 2,a
		jr z,JTIRO1
		set 3,e
JTIRO1:
		bit 4,a
		jr z,FIM_DIREC2
		set 6,e

FIM_DIREC2:

		ld a,e
		ld ($73ee),a
		ld ($73ef),a
		ret
