;;;;;;;;;;;;;;;;;[[LIMPA_SEC3];;;;;;;;;;;;;;;;;;;;;;;;;;;
LIMPA_SEC3:
	DI
	LD A,$00
	LD B,$FF
	OUT ($99),A
	LD A,$19+$40
	OUT ($99),A
	NOP
	NOP
LIMPA_SEC3_LOOP:
	LD A,$FF
	OUT ($98),A
	DEC B
	JR NZ,LIMPA_SEC3_LOOP
	OUT ($98),A
	EI
	RET
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;[[ERASE ONE LINE]];;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; D = LINHA (0 A 31)

ERASE_ONE_LINE:
	DI
LOOP_ERASE:
	LD A,$00
	ADD A,D
	OUT ($99),A
	LD A,$19+$40
	OUT ($99),A
	NOP
	NOP
	LD A,$FF
	OUT ($98),A
	LD A,D
	ADD A,32
	LD D,A
	JR NC,LOOP_ERASE
	EI
	RET
	
;;;;;;;;;;;;;;;;[[PLACE BOB]];;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;; D = START
PLACE_BOB:
	LD B,0
	DI
PLACE_BOB_LOOP_LINE:
	LD A,$00
	ADD A,D
	OUT ($99),A
	LD A,$19+$40
	OUT ($99),A
	NOP
	NOP
	LD C,6
PLACE_BOB_LOOP_COL:
	LD A,B
	OUT ($98),A
	INC B
	DEC C
	JR NZ,PLACE_BOB_LOOP_COL
	LD A,B
	ADD A,26
	LD B,A
	LD A,D
	ADD A,32
	LD D,A
	JR NC,PLACE_BOB_LOOP_LINE
	EI
	RET

;;;;;;;;;;;;;;;;[[WAIT_SOMETIME]];;;;;;;;;;;;;;;;;;;;;;;;;;;;
WAIT_SOMETIME:
;	LD C,$9
WAIT_LOOP2:
	LD B,$FF
WAIT_LOOP1:
	LD HL,$27FF
	LD A,(HL)
	RRCA
	RLCA
	DEC B
	JR NZ,WAIT_LOOP1
	DEC C
	JR NZ,WAIT_LOOP2
	RET

;;;;;;;;;;;;;;;;;;>>>>>>>>>>>>>>>> PRINT HL
PRINT_HL:
	LD C,$20
	LD A,(HL)
	XOR 5
	call CHPUT
	PUSH HL
	CALL WAIT_SOMETIME
	POP HL
	inc HL
	ld a,0
	cp (HL)
	JR NZ, PRINT_HL
	RET

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;>>>>>>>> INICIALIZA COR
INICIALIZA_COR:
	LD C,$19
	LD B,$FF
	DI
	LD A,$00
	OUT ($99),A
	LD A,$20+$40
	OUT ($99),A
	NOP
	NOP
	LD A,$F4
LOOP_COR1:
	OUT ($98),A
	DEC B
	JR NZ,LOOP_COR1
	LD B,$FF
	DEC C
	JR NZ,LOOP_COR1
	EI
	RET

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;:>>>>>>>>>>>>CRIA O LOGO NOS PATTERNS;;;;;;;;;;;;;;;;;;;;;
LOGO:	
	LD A,$00
	DI
	LD HL,MUFFIE_LOGO
	LD D,0
	LD B,8
LOOP_LOGO_LINE:
	LD A,0
	OUT ($99),A
	LD A,$08+$40
	ADD A,D
	OUT ($99),A
	NOP
	NOP
	LD C,48
LOOP_LOGO:
	LD A,(HL)
	OUT ($98),A
	INC HL
	DEC C
	JR NZ,LOOP_LOGO
	INC D
	DEC B
	JR NZ,LOOP_LOGO_LINE
	EI
	RET
	

	;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; COOL COLORS ROUTINE - TOOK FROM EXECROM - ; CoolColors (c) Fabio R. Schmidlin, 1997
DO_COOL_COLORS:		
		;<GuyveR800> BIOS address 2Dh contains the MSX version, 0=MSX1, 1=MSX2, 2=MSX2+, 3=MSXturboR
		LD HL,$2D
		LD A,(HL)
		CP $0
		JR Z,NOT_COOLCOLORS
        ld hl,7
        xor a
        out ($99),a
        ld a,144
        out ($99),a       ; set VDP to receive new palette
        ld b,16         ; set MSX1 colors:
        ld hl,COOLCOLORS   ; HL=color table
enhanc1:
		ld a,(hl)
        sla a
        sla a
        sla a
        sla a
        ld d,a          ; D=rrrr0000
        inc hl
        ld a,(hl)
        ld e,a          ; E=0000gggg
        inc hl
        ld a,(hl)
        or d            ; A=rrrrbbbb
        out ($9A),a
        ld a,e
        out ($9A),a       ; set color
        inc hl
        djnz enhanc1    ; next color

		; mudar pra 60hz em msx2 ou melhor. By Bifimsx
		LD A,($FFE8)
		AND $FD
		OUT ($99),A
		LD A,$80+$9
		OUT ($99),A
		
NOT_COOLCOLORS:
		RET
	;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; COOL COLORS ROUTINE - TOOK FROM EXECROM

COOLCOLORS:						 ; CoolColors (c) Fabio R. Schmidlin, 1997
		db 0,0,0                ; Enhanced color palette: transparent
        db 0,0,0                ;                         black
        db 2,5,3                ;                         blue
        db 3,6,4                ;                         .
        db 1,2,5                ;                         .
        db 2,3,6                ;                         .
        db 5,2,1                ;                         .
        db 3,5,7                ;                         .
        db 6,3,2                ;                         .
        db 7,4,2                ;                         .
        db 7,6,2                ;                         .
        db 7,7,4                ;                         light yellow
        db 1,4,2                ;                         yellow
        db 5,2,4                ;                         magenta
        db 5,5,5                ;                         gray
        db 7,7,7                ;                         white

		
INCLUDE musiccjacko.asm
	
	