KONAMI_SCROLL:
	CALL CLEAR_NAMETABLE_S1
	
	LD HL,KONAMI_STUFF
	CALL WRITE_VRAM_STUFF2
	
	LD HL,BLACK_PATTERN
	CALL WRITE_VRAM_STUFF2
	
	LD BC,$1AAA
	LD DE,$20

LOOP_SCROLL:
	PUSH BC
	LD HL,KONAMI_LOGO1
	INC BC
	CALL PRINT_STUFF
	DEC BC
	
	LD H,B
	LD L,C
	ADD HL,DE	
	LD B,H
	LD C,L
	LD HL,KONAMI_LOGO2
	CALL PRINT_STUFF
	LD H,B
	LD L,C
	ADD HL,DE	
	LD B,H
	LD C,L
	LD HL,KONAMI_LOGO3
	CALL PRINT_STUFF

	LD H,B
	LD L,C
	ADD HL,DE	
	LD B,H
	LD C,L
	LD HL,EMPTY_LINE
	CALL PRINT_STUFF
	
	
	HALT
	HALT
	POP BC
	LD H,B
	LD L,C
	SBC HL,DE	
	LD B,H
	LD C,L
	
	LD A,B
	CP $18
	JR NZ,LOOP_SCROLL
	LD A,C
	CP $6A
	JR NZ,LOOP_SCROLL
	
	LD A,$70
LOOP_SCROLL_WAIT:
	HALT
	DEC A
	JR NZ,LOOP_SCROLL_WAIT
	RET
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;



; SCREEN 1	: PATTERN TABLE:

KONAMI_STUFF:
	DB $80,$01						; VDP ADDRESS TO WRITE $0180
	INCBIN konamifontlogo.bin		; DATA TO WRITE
	DB $FA							; END BYTE

BLACK_PATTERN:	DB $0B,$20,$F0,$F0,$F0,$F0,$F0,$FA

KONAMI_LOGO1:	DB 114,89,$FA
KONAMI_LOGO2:	DB 90,91,92,93,94,95,96,97,98,99,100,$FA
KONAMI_LOGO3:	DB 101,102,103,104,105,106,107,108,109,110,111,112,$FA
EMPTY_LINE:		DB 0,0,0,0,0,0,0,0,0,0,0,0,$FA

; VRAM WRITE FUNCTION - END BYTE MUST BE CHANGED (LAMMAH SOLUTION)
WRITE_VRAM_STUFF2:
	LD A,(HL)
	OUT ($99),A
	INC HL
	LD A,(HL)
	OR $40
	OUT ($99),A
	INC HL
WVS_LOOP2:
	LD A,(HL)
	CP $FA			; HERE, CHANGE THE END BYTE TO SOMETHING THAT'S NOT INSIDE THE DATA
	JR Z,WVS_END2
	OUT ($98),A
	INC HL
	JR WVS_LOOP2
WVS_END2:
	RET

; HL = STUFF TO PRINT
; BC = ADDRESS TO PRINT
PRINT_STUFF:
	LD A,C
	OUT ($99),A
	LD A,B
	OR $40
	OUT ($99),A
PS_LOOP:
	LD A,(HL)
	CP $FA			; HERE, CHANGE THE END BYTE TO SOMETHING THAT'S NOT INSIDE THE DATA
	JR Z,PS_END
	OUT ($98),A
	INC HL
	JR PS_LOOP
PS_END:
	RET


	
; LIMPA A TELA EM SCREEN 1
CLEAR_NAMETABLE_S1:
	LD A,$00
	OUT ($99),A
	LD A,$18+$40
	OUT ($99),A
	LD BC,$300
CNS1_LOOP:
	LD A,$20
	OUT ($98),A
	DEC BC
	LD A,C
	OR B
	JR NZ,CNS1_LOOP
	RET


	;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; COOL COLORS ROUTINE - TOOK FROM EXECROM - ; CoolColors (c) Fabio R. Schmidlin, 1997
DO_COOL_COLORS:		
		;<GuyveR800> BIOS address 2Dh contains the MSX version, 0=MSX1, 1=MSX2, 2=MSX2+, 3=MSXturboR
		LD HL,$2D
		LD A,(HL)
		CP $0
		JR Z,NOT_COOLCOLORS
        ld hl,7
        xor a
        out ($99),a
        ld a,144
        out ($99),a       ; set VDP to receive new palette
        ld b,16         ; set MSX1 colors:
        ld hl,COOLCOLORS   ; HL=color table
enhanc1:
		ld a,(hl)
        sla a
        sla a
        sla a
        sla a
        ld d,a          ; D=rrrr0000
        inc hl
        ld a,(hl)
        ld e,a          ; E=0000gggg
        inc hl
        ld a,(hl)
        or d            ; A=rrrrbbbb
        out ($9A),a
        ld a,e
        out ($9A),a       ; set color
        inc hl
        djnz enhanc1    ; next color

		; mudar pra 60hz em msx2 ou melhor. By Bifimsx
		LD A,($FFE8)
		AND $FD
		OUT ($99),A
		LD A,$80+$9
		OUT ($99),A
		
NOT_COOLCOLORS:
		RET
	;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; COOL COLORS ROUTINE - TOOK FROM EXECROM

COOLCOLORS:						 ; CoolColors (c) Fabio R. Schmidlin, 1997
		db 0,0,0                ; Enhanced color palette: transparent
        db 0,0,0                ;                         black
        db 2,5,3                ;                         blue
        db 3,6,4                ;                         .
        db 1,2,5                ;                         .
        db 2,3,6                ;                         .
        db 5,2,1                ;                         .
        db 3,5,7                ;                         .
        db 6,3,2                ;                         .
        db 7,4,2                ;                         .
        db 7,6,2                ;                         .
        db 7,7,4                ;                         light yellow
        db 1,4,2                ;                         yellow
        db 5,2,4                ;                         magenta
        db 5,5,5                ;                         gray
        db 7,7,7                ;                         white

		

;;;;;;;;;;;;;;;;[[WAIT_SOMETIME]];;;;;;;;;;;;;;;;;;;;;;;;;;;;
WAIT_SOMETIME:
;	LD C,$9
WAIT_LOOP2:
	LD B,$FF
WAIT_LOOP1:
	LD HL,$27FF
	LD A,(HL)
	RRCA
	RLCA
	DEC B
	JR NZ,WAIT_LOOP1
	DEC C
	JR NZ,WAIT_LOOP2
	RET

;;;;;;;;;;;;;;;;;;>>>>>>>>>>>>>>>> PRINT HL
PRINT_HL:

	LD C,$20
	LD A,(HL)
	RRCA
	XOR $8
	call CHPUT
	PUSH HL
	PUSH AF

	CALL WAIT_SOMETIME

	POP AF
	POP HL
	inc HL
	ld a,0
	cp (HL)
	JR NZ, PRINT_HL
	RET

	
;;;;;;;;;;;; Rotininha para tocar o earicon da casio, agora da Muffie
TOCA_SOM_MUFFIE:
	CALL GICINI
	
	LD B,SOM_LOGO_FIM-SOM_LOGO
	LD HL,SOM_LOGO

LOOP_SOM
	LD A,(HL)
	INC HL
	LD E,(HL)

	PUSH HL
	PUSH BC
	CALL WRTPSG
	POP BC
	POP HL

	INC HL
	LD A,(HL)

WAIT_LOOP:
	CP 0
	JR Z,NO_WAIT
	
	HALT
	DEC A
	JR NZ,WAIT_LOOP

NO_WAIT:
	INC HL
	DEC B
	DEC B
	DEC B
	JR NZ,LOOP_SOM
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; fim da rotininha...
	RET
	
;	Formato de som MUFFIE: psgreg,valoracolocar,interrupcoesaesperar
;
SOM_LOGO:
		DB 7,191,3
		DB 0,80,0
		DB 2,64,0
		DB 7,184,0
		DB 8,15,0
		DB 9,15,1
		DB 10,14,1
		DB 10,13,1
		DB 10,12,1
		DB 10,11,1
		DB 10,10,1
		DB 8,14,0
		DB 9,14,0
		DB 10,9,1
		DB 10,8,1
		DB 4,32,0
		DB 10,15,4
		DB 8,13,0
		DB 9,13,2
		DB 10,14,4
		DB 8,12,0
		DB 9,12,2
		DB 10,13,4
		DB 8,11,0
		DB 9,11,2
		DB 10,12,4
		DB 8,10,0
		DB 9,10,2
		DB 10,11,4
		DB 8,9,0
		DB 9,9,2
		DB 10,10,4
		DB 8,8,0
		DB 9,8,2
		DB 10,9,4
		DB 8,7,0
		DB 9,7,2
		DB 10,8,4
		DB 8,6,0
		DB 9,6,2
		DB 10,7,4
		DB 8,5,0
		DB 9,5,2
		DB 10,6,2
		DB 7,191,0
SOM_LOGO_FIM:

CHANGE_FONT2:
	LD B,$4F
	LD HL,NEW_FONT2
	LD A,%10000000
	OUT ($99),A
	LD A,%000001+$40		; COLOQUEI A VDP PRA ESCREVER ($40) NA POSIO 180 (00000110000000), ONDE FICAM OS NUMEROS
	OUT ($99),A
	NOP
	NOP
LOOP_FONT12:
	LD A,(HL)
	OUT ($98),A
	INC HL
	DEC B
	JR NZ,LOOP_FONT12
							; AGORA AS LETRAS
	LD B,$E0
	LD A,%00001000
	OUT ($99),A
	LD A,%000010+$40		; COLOQUEI A VDP PRA ESCREVER ($40) NA POSIO 208 (, ONDE FICAM AS LETRAS
	OUT ($99),A
	NOP
	NOP
LOOP_FONT22:
	LD A,(HL)
	OUT ($98),A
	INC HL
	DEC B
	JR NZ,LOOP_FONT22

	LD A,%00000110			; agora umas cori legais
	OUT ($99),A
	LD A,%100000+$40		; COLOQUEI A VDP PRA ESCREVER ($40) NA POSIO $2006 onde ficam as cori das letras e numeros
	OUT ($99),A
	
	LD A,$30
	OUT ($98),A			; $2006
	LD A,$50
	OUT ($98),A			; $2007
	LD A,$90
	OUT ($98),A			; $2008
	LD A,$B0
	OUT ($98),A			; $2009
	LD A,$E0
	OUT ($98),A			; $200A
	LD A,$70
	OUT ($98),A			; $200B
	
	RET	
	
NEW_FONT2: 	INCBIN zeminafont.bin

	TEXTO_INTRO: DB 166,138,182,160,80,188,154,180,182,130,142,140,80,148,162,80,138,186,156,156,130,154,80,116,112,112,96,80,10,4
				 DB 180,154,146,136,80,150,142,152,130,140,158,72,80,156,142,180,80,180,154,146,136,80,138,154,140,168,168,168,10,4,10,4
				 DB 166,184,130,184,136,154,80,138,186,182,130,150,80,148,162,80,132,146,150,134,142,16,10,4
				 DB 166,148,142,160,80,138,146,140,186,146,136,80,136,146,148,154,136,80,148,162,80,138,184,134,142,140,146,138,130,16
				 DB 166,140,154,190,80,176,146,136,154,184,184,154,80,148,162,80,156,76,182,150,128,138,130,152,136,130,140,16,0

